﻿infrastructureModule
    .controller('OrganizationManageController', ['$scope', '$location', '$log', 'orgService', '$interval', 'uiGridTreeViewConstants', 'uiGridConstants', 'SweetAlert', 'projectService', '$translate', '$timeout', 'organizationStructureService', 'areaRegionService', 'apiInterceptor', 'businessUnitService', 'userService', 'roleService', '$q', 'permissionService', 'dimensionService', 'region', 'equityService', 'orgExtraService', 'loginContext',
        function ($scope, $location, $log, orgService, $interval, uiGridTreeViewConstants, uiGridConstants, SweetAlert, projectService, $translate, $timeout, organizationStructureService, areaRegionService, apiInterceptor, businessUnitService, userService, roleService, $q, permissionService, dimensionService, region, equityService, orgExtraService, loginContext) {
            'use strict';

            $scope.expanded = false;
            $scope.showOrgs = true;
            $scope.showSingle = false;
            $scope.selectNodeCount = 0;
            $scope.startDate = new Date(2019, 0, 1);
            $scope.endDate = new Date(2019, 11, 31);

            $scope.showTaxRegInfoContent = true;
            $scope.showExtraRegInfoContent = true;

            $scope.showTaxRule = false;
            $scope.showReturnRateInfo = false;
            $scope.showAccountingRateInfo = false;
            $scope.showApprovedLevyInfo = false;
            $scope.showTaxOfficerInfo = false;
            $scope.showInvoiceInfo = false;
            $scope.showTaxpayerQualification = false;
            $scope.showEmployee = false;
            $scope.isInternational = false;
            $scope.isNotHundred = false;
            $scope.editOrgExtraModel = {};

            var translate = {
                Enabled: $translate.instant('BusinessUnitActive'),  //已启用
                Disabled: $translate.instant('BusinessUnitDisabled')//已停用
            };

            //jack
            $scope.getBottomHeight = function () {

                if ($scope.isLoadComplete) {
                    var y = $(".company-detail").height();
                    var parent = $('.org-right-container').height();
                    return {height: parent - y + 'px'};
                }

                return {};
            };

            $scope.visiableTaxRegInfo = function () {
                if ($scope.showTaxRegInfoContent) {
                    $scope.showTaxRegInfoContent = false;
                } else {
                    $scope.showTaxRegInfoContent = true;
                }
            };

            $scope.visiableTaxExtraInfo = function () {
                if ($scope.showExtraRegInfoContent) {
                    $scope.showExtraRegInfoContent = false;
                } else {
                    $scope.showExtraRegInfoContent = true;
                }
            };

            //初始化ack-pagination
            $scope.pagingOptions = {
                pageIndex: 1, //当前页码
                totalItems: 0, //总数据
                totalPages: 10, //总页数
                maxSize: 5, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
                pageSizeString: constant.page.pageSizeArrary[3].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage')
            };

            // 机构树
            var tree;

            // 是佛启用禁用Map
            var isActiveMap = {
                false: 'Enable',
                true: 'Disable'
            };

            var dataType = {
                isPrefixNumber: function (value) {
                    var reg = /^\d+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixChar: function (value) {
                    var reg = /^[a-zA-Z]+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixNumberOrChar: function (value) {
                    if (dataType.isPrefixNumber(value)) {
                        return true;
                    }

                    if (dataType.isPrefixChar(value)) {
                        return true;
                    }

                    return false;
                }
            };

            var initPagingControl = function (totalItemsCount) {
                $scope.pagingOptions.totalItems = totalItemsCount;
            };

            // 初始化函数
            var initOrg = function () {
                loadorgTree();
            };

            var getOrgList = function () {
                orgService.getOrgInfoList().success(function (data) {
                    if (data) {
                        //data.forEach(function (row) {
                        //    if (row.userList) {
                        //        row.userListStr = _.map(row.userList, function (x) { return x.userName; }).join(constant.comma);
                        //    }
                        //});
                        // console.log("dat:" + JSON.stringify(data));
                        if (loginContext.userName && loginContext.userName.toLowerCase() === "simon") {
                            data = _.filter(data, function (row) {
                                return row && row.industryID === "10";
                            });
                        }
                        initPagingControl(data.length);
                        $scope.DataGridSource = data;
                        $scope.orgUserGridInstance.repaint();
                        $scope.orgUserGridInstance.refresh();
                        // console.log($scope.DataGridSource);
                        // console.log($scope.orgUserGridOptions);
                        $scope.oldData = angular.copy(data);
                        $scope.setGridHeight();
                    }
                });
            };

            // 保存启用、启用的操作结果
            $scope.updateIsActive = function () {
                $scope.isCanOrganizationIsActiveBtn = false;
                var isActive = !$scope.selectCompany.isActive;
                if (isActive) {
                    orgService.enableOrgs($scope.selectCompany.id).success(function () {
                        SweetAlert.success($translate.instant('EnableUserSuccess'));

                        $scope.selectCompany.isActive = !$scope.selectCompany.isActive;
                        $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                        $log.debug('enabled success!');
                        $scope.organizationId = $scope.selectCompany.id;
                        loadorgTree();
                    })['finally'](function () {
                        $scope.isCanOrganizationIsActiveBtn = true;

                    });
                } else {
                    var list = [];
                    list.push($scope.selectCompany.id);
                    orgService.disableOrgs(list).success(function () {
                        SweetAlert.success($translate.instant('DisableUserSuccess'));

                        $scope.selectCompany.isActive = !$scope.selectCompany.isActive;
                        $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                        $log.debug('disabled orgs success!');
                        $scope.organizationId = $scope.selectCompany.id;
                        loadorgTree();
                    })['finally'](function () {
                        $scope.isCanOrganizationIsActiveBtn = true;
                    });
                }
                // generalSelectCompanyText();
            };

            // 进入高级配置编辑状态
            $scope.editAdvancedConfigurationStatus = function () {
                $scope.selectCompany.isUpdate = true;
                setEnterpriseOrgRowList($scope.selectCompany);

                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {

                    $scope.selectCompany.organizationServiceTemplateGroupList.forEach(function (row) {

                        row.templateGroupList = _.find($scope.serviceList, function (num) {
                            return num.id === row.serviceTypeID
                        }).templateGroupList;
                    });
                }

            };

            // 保存高级配置修改
            $scope.saveAdvancedConfiguration = function () {

                if (checkEnterpriseSetOrg() || checkTemplateList() || checkServiceTypeList()) {
                    return;
                }

                var branch = {
                    data: {
                        id: $scope.selectCompany.id
                    }
                };

                orgService.updateOrg($scope.selectCompany).success(function (data) {
                    if (data && !data.result) {
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    $scope.selectOrganization(branch);
                });
            };

            // 取消高级配置修改
            $scope.cancelAdvancedConfiguration = function () {
                $scope.selectCompany.enterpriseAccountSetOrgList = angular.copy($scope.backups.enterpriseAccountSetOrgList);
                $scope.selectCompany.organizationServiceTemplateGroupList = angular.copy($scope.backups.organizationServiceTemplateGroupList);
                $scope.selectCompany.isUpdate = false;
            };

            // 关于日志部分
            $scope.showOperateLogPop = function () {
                $scope.isShowLog = true;
            };

            // 添加机构
            $scope.addOrg = function () {
                $scope.orgOperateType = constant.Operation.Add;
                $scope.isAdd = true;
                $scope.selectedOrg = null;
            };

            // 编辑机构
            $scope.updateOrg = function () {
                $scope.isAdd = false;
                $scope.orgOperateType = constant.Operation.Edit;
                $scope.selectedOrg = $scope.selectCompany;
            };

            // 取消编辑机构其他信息
            // TODO 将这个方法添加到切换功能里
            $scope.updateOrgExtraCancel = function () {
                $scope.selectCompanyExtra = $scope.comExtraOldData;
                $scope.editOrgExtraModel = $scope.editOldData;
                generalSelectCompanyExtraText();
                cancelWebChange();
            };

            var cancelWebChange = function () {
                $('.tax-extra-info-content .col-sm-8 span').removeAttr("hidden");
                $('.tax-reg-info-content .col-sm-4 span').removeAttr("hidden");
                $('.extra-organization-info .right-option .button2position').attr("hidden", "hidden");
                $('.extra-organization-info .right-option .updOrgBtn').removeAttr("hidden");
                for (var i = 0; i < $('.tax-reg-info-content .col-sm-4 input').length; i++) {
                    $('.tax-reg-info-content .col-sm-4 input')[i].style.display = "none";
                }
                for (var i = 0; i < $('.tax-reg-info-content .col-sm-4 select').length; i++) {
                    $('.tax-reg-info-content .col-sm-4 select')[i].style.display = "none";
                }
                for (var i = 0; i < $('.tax-extra-info-content .col-sm-8 input').length; i++) {
                    $('.tax-extra-info-content .col-sm-8 input')[i].style.display = "none";
                }
                for (var i = 0; i < $('.tax-extra-info-content .col-sm-8 select').length; i++) {
                    $('.tax-extra-info-content .col-sm-8 select')[i].style.display = "none";
                }
            };

            // 提交修改的机构其他信息
            $scope.updateOrgExtraSubmit = function () {
                SweetAlert.swal({
                        title: $translate.instant('ComfirmUpdate'),
                        text: $translate.instant('UpdateOrgExtraInfoTips'),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            // 选中
                            updateOrgExtraInfo($scope.selectCompany.id);
                        }
                    });
            };

            var updateOrgExtraInfo = function (id) {
                var editData = $scope.editOrgExtraModel;
                editData.organizationId = id;
                orgService.updateOrgExtraInfoByOrgId(editData).success(function (res) {
                    if (res && !res.result) {
                        SweetAlert.warning($translate.instant(res.resultMsg));
                        return;
                    }
                    if (res) {
                        orgService.getSingleOrgExtra(id).success(function (data) {
                            if (data == null) {
                                SweetAlert.warning($translate.instant(data.resultMsg));
                                return;
                            }
                            $scope.editOrgExtraModel = angular.copy(data);
                            $scope.selectCompanyExtra = data;
                            generalSelectCompanyExtraText();
                            cancelWebChange();
                            SweetAlert.success($translate.instant('OrganizationExtraInfoEditSuccess'));
                        });
                    }
                });
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    if ($scope.selectCompany && !$scope.isAdd) {
                        $scope.organizationId = $scope.selectCompany.id;
                    } else {
                        $scope.organizationId = null;
                    }
                    initOrg();
                    $scope.isOrgUpdate = false;
                }
            });


            // 选中机构
            $scope.selectOrganization = function (branch) {
                var org = branch.data;
                $scope.output = "You selected: " + org.id;

                var suborgList = getSubOrgList(branch);
                $scope.selectedOrgID = org.id;
                // 选中事件
                // $scope.selectCompany = org;
                orgService.getSingleOrg(org.id).success(function (data) {
                    if ($scope.selectNodeCount > 1) {
                        $scope.showOrgs = false;
                        $scope.showSingle = true;
                    }
                    $scope.selectNodeCount++;
                    $scope.selectCompany = data;
                    $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                    $scope.selectCompany.suborgList = suborgList;
                    $scope.backups = {};
                    $scope.backups.enterpriseAccountSetOrgList = angular.copy($scope.selectCompany.enterpriseAccountSetOrgList);
                    $scope.backups.organizationServiceTemplateGroupList = angular.copy($scope.selectCompany.organizationServiceTemplateGroupList);

                    var orgAttributeList = _.filter(data.dimensionValueOrgList, function (attr) {
                        if (attr.id) {
                            return true;
                        } else {
                            return false;
                        }
                    });

                    var orgAttributeRowList = [];

                    if (orgAttributeList && orgAttributeList.length > 0) {

                        $scope.firstAttribute = orgAttributeList[0];

                        for (var i = 1; i < orgAttributeList.length; i = i + 2) {
                            var model = {
                                left: orgAttributeList[i]
                            };
                            if (i + 1 < orgAttributeList.length) {
                                model.right = orgAttributeList[i + 1];
                            }
                            orgAttributeRowList.push(model);
                        }
                    }

                    $scope.selectCompany.orgAttributeRowList = orgAttributeRowList;

                    $scope.isInternational = $scope.selectCompany.oversea;

                    cancelWebChange();
                });
            };

            $scope.resources = {
                EffectiveDateRequired: $translate.instant('EffectiveDateRequired'),
                ExpiredDateRequired: $translate.instant('ExpiredDateRequired'),
                EffectiveDateAreaProblem: $translate.instant('EffectiveDateAreaProblem'),
                OrganizationMsgTemplateRequired: $translate.instant('OrganizationMsgTemplateRequired'),
                OrganizationMsgProjectIndustryRequired: $translate.instant('OrganizationMsgProjectIndustryRequired'),
                ServiceExists: $translate.instant('ServiceExists'),
                DateMonthFormatError: $translate.instant('DateMonthFormatError')
            };

            $scope.collapseOrgExtraInfoAll = function () {
                $scope.showTaxRegInfoContent = false;
                $scope.showExtraRegInfoContent = false;
                $scope.showTaxRule = false;
                $scope.showReturnRateInfo = false;
                $scope.showAccountingRateInfo = false;
                $scope.showApprovedLevyInfo = false;
                $scope.showTaxOfficerInfo = false;
                $scope.showInvoiceInfo = false;
                $scope.showTaxpayerQualification = false;
                $scope.showEmployee = false;
                $scope.expanded = false;
            };
            $scope.expandOrgExtraInfoAll = function () {
                $scope.showTaxRegInfoContent = true;
                $scope.showExtraRegInfoContent = true;
                $scope.showTaxRule = true;
                $scope.showReturnRateInfo = true;
                $scope.showAccountingRateInfo = true;
                $scope.showApprovedLevyInfo = true;
                $scope.showTaxOfficerInfo = true;
                $scope.showInvoiceInfo = true;
                $scope.showTaxpayerQualification = true;
                $scope.showEmployee = true;
                $scope.expanded = true;
            };

            // 验证开始时间
            $scope.checkStartDate = function (row) {


                // if (!row.effectiveDateStr) {
                //     row.startDateError = $scope.resources.EffectiveDateRequired;
                // } else {
                //     row.startDateError = null;
                // }

                if (row.effectiveDateStr && !window.PWC.checkMonth(row.effectiveDateStr)) {
                    row.startDateError = $scope.resources.DateMonthFormatError;
                    return;
                } else {
                    row.startDateError = null;
                }

                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.startDateError = null;
                    return;
                }

                if (row.effectiveDateStr && row.expiredDateStr) {

                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                    } else {
                        row.startDateError = null;
                    }
                }
            };

            // 验证结束时间
            $scope.checkEndDate = function (row) {

                //结束时间可为空，默认9999-12
                // if (!row.expiredDateStr) {
                //     row.endDateError = $scope.resources.ExpiredDateRequired;
                // } else {
                //     row.endDateError = null;
                // }

                if (row.expiredDateStr && !window.PWC.checkMonth(row.expiredDateStr)) {
                    row.endDateError = $scope.resources.DateMonthFormatError;
                    return;
                } else {
                    row.endDateError = null;
                }

                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.endDateError = null;
                    return;
                }

                if (row.effectiveDateStr && row.expiredDateStr) {
                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                    } else {
                        row.startDateError = null;
                    }
                }
            };

            // 加载机构树
            $scope.my_tree = tree = {};

            var loadorgTree = function () {

                $scope.orgList = [];
                $scope.doing_async = true;

                $scope.showOrgTree = false;

                orgService.getOrgListToJson(1).success(function (data) {
                    $scope.orgList = data;
                    $log.debug(data);
                    // 设置默认选中机构
                    if (data && data.length > 0) {

                        var selectOrg = data[0];
                        if ($scope.organizationId) {
                            selectOrg = findBranch($scope.organizationId, $scope.orgList);
                            if (!selectOrg) {
                                selectOrg = data[0];
                            }
                        }

                        $scope.selectOrganization(selectOrg);
                    }

                    $scope.doing_async = false;

                    return $timeout(function () {
                        $scope.my_tree.expand_level_function();
                        $scope.my_tree.select_branch(selectOrg);
                        $scope.showOrgTree = true;
                    }, 200);

                    return tree.expand_level_function();

                }).error(function (data) {

                    $log.debug(JSON.stringify(data));
                });
            };

            // 查找选中的分支
            var findBranch = function (orgid, orgTree) {
                if (orgTree && orgTree.length > 0) {

                    for (var i = 0; i < orgTree.length; i++) {
                        var row = orgTree[i];

                        // 查看当前节点
                        if (row.data.id === orgid) {
                            target = row;
                            return target;
                        }

                        // 查看子节点
                        var target = findBranch(orgid, row.children);
                        if (target) {
                            return target;
                        }
                    }

                    return null;
                } else {
                    return null;
                }
            };

            // 验证是否为时间段
            var validateDate = function (from, to) {
                var fromDate = new Date(from + '-01');
                var toDate = new Date(to + '-01');
                toDate.setMonth(toDate.getMonth() + 1);
                toDate.setDate(toDate.getDate() - 1);

                if (fromDate <= toDate) {
                    return true;
                } else {
                    return false;
                }
            };

            // 获取当前机构下的子机构
            var getSubOrgList = function (branch) {

                var orgList = [];

                if (branch.children && branch.children.length > 0) {
                    branch.children.forEach(function (row) {
                        orgList.push(row.data);
                        var tempList = getSubOrgList(row);
                        if (tempList && tempList.length > 0) {
                            orgList = _.union(orgList, tempList);
                        }
                    });
                }

                return orgList;
            };

            $scope.permissionPopover = {
                //content: $scope.permissionList,
                templateUrl: 'permissionPopoverTemplate.html',
                title: $translate.instant('TPermission')
            };

            //Jack
            $scope.showPermission = function (item) {

                var roleID = item.id;
                $scope.permissionList = [];
                var currentPermission = _.find($scope.allRolePermission, function (row) {
                    return row.roleID == roleID;
                });
                if (currentPermission && currentPermission.permissionList) {
                    $scope.permissionList = currentPermission.permissionList;
                    var copyData = angular.copy(currentPermission.permissionList);
                    copyData.forEach(function (item) {
                        var findParent = _.find(currentPermission.permissionList, function (num) {
                            return num.id === item.parentID;
                        });
                        if (!findParent) {
                            item.parentID = null;
                        }
                    });

                    $scope.permissionTreeViewData = copyData;// currentPermission.permissionList;
                    // console.log(JSON.stringify($scope.permissionTreeViewData));
                }
                // console.log(JSON.stringify(item));
            };

            $scope.getGridHeight = function () {
                return {height: $(".dx-viewport").height() + "px"};
            };

            // 初始化参数信息
            var initParams = function () {
                $scope.showRowLines = true;
                $scope.orgList = [];
                $scope.checkedOrgsSet = {};
                $scope.set = [];
                $scope.maxTitleLength = 10;
                $scope.maxValueLength = 20;
                $scope.selectCompany = {};
                $scope.showAttributeDimensionID = 'orgmanage';
                $scope.searchText = '';
                $scope.isCanOrganizationIsActiveBtn = true;
                $scope.currentNavItem = 'page1';
                $scope.userRoleList = "[]";

                $scope.taxReturnBusinessTypeList = constant.TaxReturnBusinessTypeList;
                $scope.trueFalse = constant.trueFalse;
                $scope.regFinancialAccountingTypeList = constant.RegFinancialAccountingTypeList;
                $scope.nationalEconomicIndustryList = constant.NationalEconomicIndustryList;
                $scope.applicableAccountingRuleList = constant.ApplicableAccountingRuleList;
                $scope.regStatusList = constant.RegStatusList;
                $scope.lowValueConsumablesAmortizationMethodList = constant.LowValueConsumablesAmortizationMethodList;
                $scope.depreciationMethodList = constant.DepreciationMethodList;
                $scope.taxCreditRatingList = constant.TaxCreditRatingList;
                $scope.architectureTypeList = constant.ArchitectureTypeList;
            };

            var loadDatagrid = function () {
                $scope.orgUserGridOptionsA = {
                    bindingOptions: {
                        dataSource: 'DataGridSource'
                    },
                    // height:700,
                    showBorders: true,
                    paging: {
                        pageSize: constant.page.logPageSize
                    },
                    pager: {
                        showPageSizeSelector: true,
                        allowedPageSizes: constant.page.pageSizeArrary,
                        showInfo: true
                    },
                    // export: {
                    //     enabled: false,
                    //     fileName: "机构信息列表"
                    // },
                    // columnChooser: {
                    //     enabled: true
                    // },
                    keyExpr: "name",
                    columns: [
                        {
                            dataField: "name",
                            caption: $translate.instant('OrganizationName'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    $('<a class="hyper-link">' + options.value + '</a>')
                                        .attr('href', 'javascript:void(0)')
                                        .on('click', function () {
                                            gotoOrg(options.row.data);
                                        })
                                        .appendTo(container);
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "code",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('OrganizationCode')
                        },
                        {
                            dataField: "taxPayerNumber",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('TaxPayerNumber')
                        },
                        {
                            dataField: "structureName",
                            caption: $translate.instant('OrganizationStructureDesc')
                        },
                        {
                            dataField: "regionName",
                            caption: $translate.instant('AreaRegionTitle'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessUnitName",
                            caption: $translate.instant('BusinessUnitTitleName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "areaName",
                            caption: $translate.instant('AreaTitleName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "industryName",
                            caption: $translate.instant('PIndustry'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "isActive",
                            caption: $translate.instant('EnableStatus'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    if (options.data.isActive) {
                                        $('<span>').text(translate.Enabled).appendTo(container);
                                    } else {
                                        $('<span style="color:gray">').text(translate.Disabled).appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "englishName",
                            caption: $translate.instant('OrganizationNameEn'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "abbreviation",
                            caption: $translate.instant('Abbreviation'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "foundationDate",
                            caption: $translate.instant('FoundationDate'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationLocation",
                            caption: $translate.instant('RegistrationLocation'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationLocationEn",
                            caption: $translate.instant('RegistrationLocationEn'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonName",
                            caption: $translate.instant('LegalPersonName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessScope",
                            caption: $translate.instant('BusinessScope'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regStatus",
                            caption: $translate.instant('RegStatus'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "architectureType",
                            caption: $translate.instant('ArchitectureType'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalEconomicIndustry",
                            caption: $translate.instant('NationalEconomicIndustry'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "engageNationalProhibitIndustry",
                            caption: $translate.instant('EngageNationalProhibitIndustry'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationCapital",
                            caption: $translate.instant('RegistrationCapital'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "paidInCapital",
                            caption: $translate.instant('PaidInCapital'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "numOfBranches",
                            caption: $translate.instant('NumOfBranches'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "unifiedSocialCreditCode",
                            caption: $translate.instant('UnifiedSocialCreditCode'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialAccountingType",
                            caption: $translate.instant('RegFinancialAccountingType'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxRegStatus",
                            caption: $translate.instant('TaxRegStatus'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxCreditRating",
                            caption: $translate.instant('TaxCreditRating'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "applicableAccountingRule",
                            caption: $translate.instant('ApplicableAccountingRule'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "lowValueConsumablesAmortizationMethod",
                            caption: $translate.instant('LowValueConsumablesAmortizationMethod'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "depreciationMethod",
                            caption: $translate.instant('DepreciationMethod'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "accountingSoftware",
                            caption: $translate.instant('AccountingSoftware'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "completeRecordTotalInstitutions",
                            caption: $translate.instant('CompleteRecordTotalInstitutions'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonName",
                            caption: $translate.instant('TaxClientPersonName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonPhoneNum",
                            caption: $translate.instant('TaxClientPersonPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonIdNum",
                            caption: $translate.instant('TaxClientPersonIdNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "ticketHolderName",
                            caption: $translate.instant('TicketHolderName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "ticketHolderPhoneNum",
                            caption: $translate.instant('TicketHolderPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxHallAddress",
                            caption: $translate.instant('NationalTaxHallAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxAdministratorName",
                            caption: $translate.instant('NationalTaxAdministratorName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxAdministratorPhoneNum",
                            caption: $translate.instant('NationalTaxAdministratorPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxHallAddress",
                            caption: $translate.instant('LocalTaxHallAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxAdministratorName",
                            caption: $translate.instant('LocalTaxAdministratorName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxAdministratorPhoneNum",
                            caption: $translate.instant('LocalTaxAdministratorPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "etaWebsite",
                            caption: $translate.instant('EtaWebsite'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "signTripartiteAgreement",
                            caption: $translate.instant('SignTripartiteAgreement'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "reportingCurrency",
                            caption: $translate.instant('ReportingCurrency'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "consolidationTime",
                            caption: $translate.instant('ConsolidationTime'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "fiscalYearDeadline",
                            caption: $translate.instant('FiscalYearDeadline'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxAgent",
                            caption: $translate.instant('TaxAgent'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxAgentContact",
                            caption: $translate.instant('TaxAgentContact'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "otherFacts",
                            caption: $translate.instant('OtherFacts'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxReturnBusinessType",
                            caption: $translate.instant('TaxReturnBusinessType'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "smallMeagerProfit",
                            caption: $translate.instant('SmallMeagerProfit'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "listedCompany",
                            caption: $translate.instant('ListedCompany'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "applicableAccountingStandardsOrAccountingSystems",
                            caption: $translate.instant('ApplicableAccountingStandardsOrAccountingSystems'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxPayerNumberVat",
                            caption: $translate.instant('TaxPayerNumberVat'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxPayerNumberCit",
                            caption: $translate.instant('TaxPayerNumberCit'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonEmailAddress",
                            caption: $translate.instant('TaxClientPersonEmailAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "bankAccountName",
                            caption: $translate.instant('BankAccountName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "bankAccountNumber",
                            caption: $translate.instant('BankAccountNumber'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonPhoneNumber",
                            caption: $translate.instant('LegalPersonPhoneNumber'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonLandlineNum",
                            caption: $translate.instant('LegalPersonLandlineNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonEmailAddress",
                            caption: $translate.instant('LegalPersonEmailAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerName",
                            caption: $translate.instant('RegFinancialOfficerName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerPhoneNum",
                            caption: $translate.instant('RegFinancialOfficerPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerLandlineNum",
                            caption: $translate.instant('RegFinancialOfficerLandlineNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerEmailAddress",
                            caption: $translate.instant('RegFinancialOfficerEmailAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "actualBusinessAddress",
                            caption: $translate.instant('ActualBusinessAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "secondaryApprovalAmount",
                            caption: $translate.instant('SecondaryApprovalAmount'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessRegistrationNumber",
                            caption: $translate.instant('BusinessRegistrationNumber'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "parValue",
                            caption: $translate.instant('ParValue'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "issuedShares",
                            caption: $translate.instant('IssuedShares'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "directors",
                            caption: $translate.instant('Directors'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "logoutTime",
                            caption: $translate.instant('LogoutTime'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxRuleIntroduction",
                            caption: $translate.instant('TaxRuleIntroduction'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "auditRequirements",
                            caption: $translate.instant('AuditRequirements'),
                            visible: false,
                            allowHeaderFiltering: false
                        }
                    ],
                    // masterDetail: {
                    //     enabled: false,
                    //     template: "detail"
                    // },
                    onContentReady: function (e) {
                        $scope.orgUserGridInstance = e.component;
                        // $scope.orgTreeList = e;
                        // $scope.orgTreeListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    allowColumnReordering: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var gotoOrg = function (org) {
                $scope.showOrgs = false;
                console.log(org);
                $scope.selectCompany = org;
                $scope.showSingle = true;
            };

            $scope.showAll = function () {
                $scope.showOrgs = true;
                $scope.showSingle = false;
                $scope.selectCompany = {};
            };

            $scope.uploadAttach = function () {

            };

            (function initialize() {
                $log.debug('organizationManageController.ctor()...');
                $scope.title = $translate.instant('OrganizationManageTitle');
                initParams();
                loadDatagrid();
                initOrg();
                $timeout(function () {
                    getOrgList();
                }, 200);
                $scope.location = $scope.$root.isFront;
                $timeout(function () {
                    $scope.isLoadComplete = true;
                    if ($scope.location) {
                        $scope.showHeader = false;
                    }
                    else {
                        $scope.showHeader = true;
                    }
                }, 500);
            })();
        }
    ]);
