﻿commonModule.
controller('editOrganizationModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', 'areaRegionService', '$filter', 'SweetAlert', 'regionService', 'orgService', 'organizationStructureService', 'businessUnitService', 'projectService', 'dimensionService',
    function ($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, areaRegionService, $filter, SweetAlert, regionService, orgService, organizationStructureService, businessUnitService, projectService, dimensionService) {

        var selectedModel = '.addOrgControlPop'; //'#addOrgControlPop' + $scope.dimensionId;

        $scope.pleaseSelect = $translate.instant('PleaseSelect');
        $scope.startDate = new Date(new Date().getFullYear() - 20, 1, 1);
        $scope.endDate = new Date(new Date().getFullYear() + 20, 1, 1);
        $scope.viewMode = 'days';

        var defaultSelcectRegion = {
            id: 0,
            name: '',
            shortName: '',
            mergerName: '',
        };

        $scope.showPage = function (pageIndex) {

            // if (pageIndex === 0)
            // {
            //     $('#orgModalFooter').css('padding-left','139px');
            // } else{
            //     $('#orgModalFooter').css('padding-left','35px');
            // }

        };

        // 新建机构
        var newOrg = function () {
            $scope.editOrgModel = {
                TypeLevel: 1,
                code:''

            };

            refreshOrg();

            $scope.isAdd = true;
            $scope.isShowBasic = false;
            $scope.isShowAdvanced = false;
            $scope.isShowRight = false;
            $scope.selfDimensionError = false;

            // 选项清空
            $scope.selectLevelType = null;
            $scope.selectProvince = null;
            $scope.selectRegionID = null;

            $scope.componentSelectedArea = null;
            $scope.selectRegion = defaultSelcectRegion;
            $scope.selectProjectIndustry = null;
            $scope.selectBusinessUnit = null;
            if ($scope.newOrganization) {

                // 默认事业部
                if ($scope.newOrganization.businessUnitID) {
                    $scope.selectBusinessUnit = _.find($scope.businessUnitList, function (num) {
                        return num.ID === $scope.newOrganization.businessUnitID;
                    });
                }

                // 默认区域
                if ($scope.newOrganization.areaID && $scope.newOrganization.areaName) {
                    $scope.editOrgModel.areaID = $scope.newOrganization.areaID;
                    $scope.editOrgModel.areaName = $scope.newOrganization.areaName;
                }
            }


            // $scope.orgAccountList = [];
            $scope.serviceList = [];
            $scope.isCheckedServiceList = [];
            // $scope.OrgAccountRowIndex = 1;
            // $scope.newOrgAccountRow();

            $scope.selfDimensionModel = getAddOrgSetDimension();
            // initIsCheckedServiceList();
            // resetErrorStatus();
            $scope.orgControlForm.$setPristine();
            $scope.advancedControlForm.$setPristine();
            // set first active page is basic info
            $('#orgControlTab a:first').tab('show');
            // $('#orgModalFooter').css('padding-left','139px');
            $(selectedModel).modal('show');
        };

        $scope.nameKeyUp = function(){
            var hasSpecialChar = window.PWC.hasSpecialChar($scope.editOrgModel.name);

            if (hasSpecialChar){
                $scope.editOrgModel.nameError = $translate.instant('SpecialChar');
            } else{
                $scope.editOrgModel.nameError = null;
            }
        };

        // 保存机构
        $scope.saveOrg = function () {
            if($scope.isInternational){
                saveInternationalOrg();
            }else{
                saveLocalOrg();
            }
        };

        var saveInternationalOrg = function () {
            $scope.orgControlForm.$setSubmitted();
            if(saveVerify()) return;
            var editModel = $scope.editOrgModel;

            // 是否为境外企业
            editModel.oversea = $scope.isInternational;

            if((typeof $scope.editOrgModel.logoutTime) ==="string"){
                if (""!==($scope.editOrgModel.logoutTime)) {
                    $scope.editOrgModel.logoutTime = new Date($scope.editOrgModel.logoutTime);
                }
            }

            if((typeof $scope.editOrgModel.foundationDate) ==="string"){
                if (""!==($scope.editOrgModel.foundationDate)) {
                    $scope.editOrgModel.foundationDate = new Date($scope.editOrgModel.foundationDate);
                }
            }

            //事业部
            if ($scope.selectBusinessUnit) {
                editModel.businessUnitID = $scope.selectBusinessUnit.ID;
            }
            //区域
            if ($scope.componentSelectedArea) {
                editModel.areaID = $scope.selectedAreaId;
            }

            //所属业务线校验
            if(!editModel.businessUnitID){
                SweetAlert.error("请检查必填项");
                return;
            }
            //区域校验
            if (editModel.areaID === "") {
                SweetAlert.error("请检查必填项");
                return;
            }

            if ($scope.isAdd) {
                editModel.isActive = true;
                orgService.addOrg(editModel).success(function (orgId) {
                    if (orgId && !orgId.result) {
                        SweetAlert.warning($translate.instant(orgId.resultMsg));
                        return;
                    }

                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            } else {
                if (editModel.parentID && $scope.selectedOrganization.suborgList) {

                    if (editModel.parentID === editModel.id) {
                        SweetAlert.warning('上级机构不能为机构本身');
                        return;
                    }

                    var subOrg = _.find($scope.selectedOrganization.suborgList, function (row) {
                        return row.id === editModel.parentID;
                    });

                    if (subOrg) {
                        SweetAlert.warning('不能将当前机构的下级机构设置为其上级公司');
                        return;
                    }
                }
                // editModel.isActive = !editModel.isActive;
                orgService.updateOrg(editModel).success(function (data) {
                    if (data && !data.result) {
                        //SweetAlert.info("Disable", orgId);
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }

                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            }
        };

        var saveVerify =function () {

            var fail = false;

            if($('.localRequired').attr("required")==="required"){
                $('.localRequired').each( function (index,ele){
                    if(null==ele.value||""===ele.value){
                        SweetAlert.error("请检查必填项");
                        fail = true;
                        return false;
                    }
                });
            }
            $('.orgAreaRequired').each( function (index,ele){
                if(null==ele.innerText||""===ele.innerText){
                    SweetAlert.error("请检查必填项");
                    fail = true;
                    return false;
                }
            });
            var taxPlayer=$scope.editOrgModel.taxPayerNumber;
            if(!(taxPlayer.length===18)){
                SweetAlert.error($translate.instant('UnifiedSocialCreditCode')+"长度必须为18位");
                fail = true;
                return fail;
            }
            return fail;
        };

        var saveLocalOrg = function () {
            $scope.orgControlForm.$setSubmitted();
           

            // var fail = false;

            // if($('.localRequired').attr("required")==="required"){
            //     $('.localRequired').each( function (index,ele){
            //         if(null==ele.value||""===ele.value){
            //             SweetAlert.error("请检查必填项");
            //             fail = true;
            //             return false;
            //         }
            //     });
            // };
            // $('.orgAreaRequired').each( function (index,ele){
            //     if(null==ele.innerText||""===ele.innerText){
            //         SweetAlert.error("请检查必填项");
            //         fail = true;
            //         return false;
            //     }
            // });
            console.log(saveVerify());

            if(saveVerify()) return;

            var hasSpecialChar = window.PWC.hasSpecialChar($scope.editOrgModel.name);
            if (hasSpecialChar) {
                $scope.editOrgModel.nameError = $translate.instant('SpecialChar');
                $scope.isShowBasic = true;
                return false;
            }

            if ($scope.orgControlForm.$invalid ) {
                $scope.isShowBasic = true;
                return;
            } else {
                $scope.isShowBasic = false;
            }

            if (checkEnterpriseSetOrg() || checkTemplateList()) {
                $scope.isShowAdvanced = true;
                return;
            } else {
                $scope.isShowAdvanced = false;
            }

            //$scope.advancedControlForm.$setSubmitted();
            //if ($scope.advancedControlForm.$invalid) {
            //    $scope.isShowAdvanced = true;
            //    return;
            //} else {
            //    $scope.isShowAdvanced = false;
            //}

            //客户代码是固定死的
            // $scope.editOrgModel.clientCode = $scope.projectClientName;
            var editModel = $scope.editOrgModel;

            // 是否为境外企业
            editModel.oversea = $scope.isInternational;

            //判断新增或修改
            //$scope.isAdd = editModel.SaveAsNew;

            if ($scope.selectProjectIndustry) {
                editModel.industryID = $scope.selectProjectIndustry.id;
            }

            //层级
            if ($scope.selectLevelType) {
                editModel.structureID = $scope.selectLevelType.id;
                editModel.structureName = $scope.selectLevelType.name;
            }

            // 区域是必填项
            if ($scope.selectProvince && ($scope.selectCity || $scope.selectRegionID)) {
                editModel.regionID = $scope.selectRegionID || $scope.selectCity.regionID;
            }

            var pId = editModel.parentID;
            //上级公司
            if (!pId || pId === constant.organization.parentIdNull) {
                editModel.parentID = constant.organization.parentIdNull;
            }
            //事业部
            if ($scope.selectBusinessUnit) {
                editModel.businessUnitID = $scope.selectBusinessUnit.ID;
            }
            //区域
            if ($scope.componentSelectedArea) {
                editModel.areaID = $scope.selectedAreaId;
            }

            //所属业务线校验
            if(!editModel.businessUnitID){
                SweetAlert.error("请检查必填项");
                return;
            }
            //区域校验
            if (editModel.areaID === "") {
                SweetAlert.error("请检查必填项");
                return;
            }

            if((typeof $scope.editOrgModel.foundationDate) ==="string"){
                if (""!==($scope.editOrgModel.foundationDate)) {
                    $scope.editOrgModel.foundationDate = new Date($scope.editOrgModel.foundationDate);
                }
            }

            //账套
            if ($scope.orgAccountList) {
                $scope.editOrgModel.enterpriseAccountSetOrgList = [];
                $scope.orgAccountList.forEach(function (row) {
                    if (row.enterpriseAccountSetSelectID) {
                        var enterpriseAccountSetOrg = {};
                        enterpriseAccountSetOrg.enterpriseAccountSetID = row.enterpriseAccountSetSelectID;
                        enterpriseAccountSetOrg.effectiveDateStr = row.startDate;
                        enterpriseAccountSetOrg.expiredDateStr = row.endDate;
                        enterpriseAccountSetOrg.organizationID = $scope.editOrgModel.id;
                        enterpriseAccountSetOrg.id = row.id;
                        $scope.editOrgModel.enterpriseAccountSetOrgList.push(enterpriseAccountSetOrg);
                    }
                });
            }
            //服务
            if ($scope.isCheckedServiceList) {
                $scope.editOrgModel.organizationServiceTemplateGroupList = [];
                $scope.isCheckedServiceList.forEach(function (row) {
                    if (row.isChecked) {
                        var organizationServiceTemplateGroup = {};
                        organizationServiceTemplateGroup.organizationID = $scope.editOrgModel.id;
                        organizationServiceTemplateGroup.serviceTypeID = row.id;
                        organizationServiceTemplateGroup.templateGroupID = row.selectedTemplate.id;
                        $scope.editOrgModel.organizationServiceTemplateGroupList.push(organizationServiceTemplateGroup)
                    }
                });
            }

            // 自定义属性
            editModel.dimensionValueOrgList = getSelfDimensionSetValueList();

            if ($scope.selfDimensionError) {
                $scope.isShowBasic = true;
                return;
            }

            if ($scope.isAdd) {
                editModel.isActive = true;
                orgService.addOrg(editModel).success(function (orgId) {
                    if (orgId && !orgId.result) {
                        SweetAlert.warning($translate.instant(orgId.resultMsg));
                        return;
                    }
                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            } else {
                if (editModel.parentID && $scope.selectedOrganization.suborgList) {

                    if (editModel.parentID === editModel.id) {
                        SweetAlert.warning('上级机构不能为机构本身');
                        return;
                    }
                    var subOrg = _.find($scope.selectedOrganization.suborgList, function (row) {
                        return row.id === editModel.parentID;
                    });

                    if (subOrg) {
                        SweetAlert.warning('不能将当前机构的下级机构设置为其上级公司');
                        return;
                    }
                }
                // editModel.isActive = !editModel.isActive;
                orgService.updateOrg(editModel).success(function (data) {
                    if (data && !data.result) {
                        //SweetAlert.info("Disable", orgId);
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }
                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            }
        };

        // 获取设置的DimensionValue
        var getSelfDimensionSetValueList = function () {
            $scope.selfDimensionError = false;
            var dimensionValueOrgList = [];
            if (!$scope.selfDimensionModel) {
                return dimensionValueOrgList;
            }

            if ($scope.selfDimensionModel.leftList && $scope.selfDimensionModel.leftList.length > 0) {
                $scope.selfDimensionModel.leftList.forEach(function (row) {
                    if (row.selectDimensionValueID) {
                        var dimensionValueOrg = {
                            dimensionValueID: row.selectDimensionValueID,
                            dimensionID: row.id,
                            organizationID: $scope.editOrgModel.id,
                        };

                        dimensionValueOrgList.push(dimensionValueOrg);
                        row.error = '';
                    } else {
                        if (row.isMandatory && row.dimensionValueList && row.dimensionValueList.length > 0) {
                            row.error = $translate.instant('PleaseSelect');

                            $scope.selfDimensionError = true;
                        } else {
                            row.error = '';
                        }
                    }
                });
            }

            if ($scope.selfDimensionModel.rightList && $scope.selfDimensionModel.rightList.length > 0) {
                $scope.selfDimensionModel.rightList.forEach(function (row) {
                    if (row.selectDimensionValueID) {
                        var dimensionValueOrg = {
                            dimensionValueID: row.selectDimensionValueID,
                            dimensionID: row.id,
                            organizationID: $scope.editOrgModel.id,
                        };

                        dimensionValueOrgList.push(dimensionValueOrg);
                        row.error = '';
                    } else {
                        if (row.isMandatory && row.dimensionValueList && row.dimensionValueList.length > 0) {
                            row.error = $translate.instant('PleaseSelect');

                            $scope.selfDimensionError = true;
                        } else {
                            row.error = '';
                        }
                    }
                });
            }

            return dimensionValueOrgList;
        };

        // 加载机构
        var loadOrg = function (orgId) {
            resetRegion();

            //清空组织机构，重新获取，达到刷新效果
            $scope.editOrgModel = {
                TypeLevel: 1
            };

            refreshOrg();
            $scope.isShowBasic = false;
            $scope.orgControlForm.$setPristine();

            if (!orgId) {
                orgId = $scope.selectCompany.id;
            }
            $("#selectedOrgName-error").hide();
            $scope.isAdd = false;
            $scope.orgHasAccountMapping = false;
            // enterpriseAccountService.getAccountMappingOrg(orgId).success(function (data) {
            //     if (data && data.length > 0) {
            //         $scope.orgHasAccountMapping = true;
            //     }
            //
            // });

            orgService.getSingleOrg(orgId).success(function (orgData) {

                $scope.selectCompany = orgData;
                // 设置上级公司
                if (orgData.parentName == null || orgData.parentID == null) {
                    var NoOptions = {
                        'id': constant.organization.parentIdNull,
                        'name': $translate.instant('OrgSelectNoOption')
                    };
                    orgData.parentName = NoOptions.name;
                    orgData.parentID = NoOptions.id;
                }

                $scope.isInternational = $scope.selectCompany.oversea;
                $scope.isLocal = !$scope.isInternational;

                $scope.selfDimensionError = false;

                // 设置层级
                $scope.selectLevelType = _.find($scope.levelTypeList, function (num) {
                    return num.id === orgData.structureID;
                });
                // 设置行业

                $scope.selectProjectIndustry = _.find($scope.projectIndustryList, function (num) {
                    return num.id === orgData.industryID;
                });

                $scope.editOrgModel = orgData;
                $scope.editOrgModel.foundationDate=($filter('date')(new Date($scope.editOrgModel.foundationDate), "yyyy-MM-dd"));

                // 设置地区
                loadProvinceList();

                loadCityList(orgData.parentRegionID);

                //设置事业部
                var businessUnitList = $scope.businessUnitList;
                $scope.selectBusinessUnit = _.find(businessUnitList, function (num) {
                    return num.ID === orgData.businessUnitID;
                });

                if ($scope.selectBusinessUnit === undefined) {
                    //angular方式控制出现了很多问题，暂时先用这样的解决方案
                    $scope.selectBusinessUnit = $scope.businessUnitList[0]; //直接选第一个，“请选择”
                    // $('#selectBusinessUnit').append('<option disabled selected="selected">' + orgData.businessUnitName + '</option>');
                }



                $scope.orgAccountList = [];
                $scope.serviceList = [];
                $scope.OrgAccountRowIndex = 1;

                $scope.selfDimensionModel = getUpdateOrgSetDimension(orgData.id, orgData.dimensionValueOrgList);
                setEnterpriseOrgRowList(orgData);
                // setIsCheckedServiceList(orgData);

            });

            if($scope.isInternational){
                $('.localRequired').removeAttr("required");
                $('.orgAreaRequired').removeAttr("required");
            }

            // set first active page is basic info
            $('#orgControlTab a:first').tab('show');
            // $('#orgModalFooter').css('padding-left','139px');
            $(selectedModel).modal('show');
        };

        var populateDDL = function (data) {
            if (data) {
                var findSelect = _.find(data, function (item) {
                    return item.id == -1;
                });
                if (!findSelect) {
                    data.unshift({ id: -1, name: $scope.pleaseSelect });
                }
            }
            return data;
        };


        $scope.removeDisabled = function () {
            var businessUnitList = $scope.businessUnitList;
            $scope.businessUnitList = _.without(businessUnitList, _.findWhere(businessUnitList, {
                id: 'newadd'
            }));
        };

        // 重置机构信息
        var resetRegion = function () {

            var defaultData = null;
            $scope.CityList = defaultData;
            $scope.ProvinceList = defaultData;
            $scope.selectProvince = defaultData;
            $scope.selectCity = defaultData;
            $scope.selectRegionID = defaultData;
        };


        // 获取机构层级
        var loadOrganizationStructureService = function () {
            organizationStructureService.getOrganizationStructureList().success(function (data) {
                var filterData = _.filter(data, function (num) {
                    return num.isActive;
                });
                $scope.levelTypeList = filterData;
            });
        };

        // 获取事业部
        var loadBusinessUnitList = function () {
            businessUnitService.getBusinessUnitList().success(function (data) {
                var filterData = _.filter(data, function (item) {
                    return item.isActive;
                });
                $scope.businessUnitList = populateDDL(filterData);
            });
        };

        //获取项目客户信息
        // var loadprojectClient = function () {
        //     projectService.getProjectClientList().success(function (data) {
        //         if (data && data.length > 0) {
        //             $scope.projectClientName = data[0].name;
        //         }
        //     });
        // };

        // 获取省市
        var loadProvinceList = function () {

            areaRegionService.getProvinces().success(function (data) {
                if (data && data.length > 0) {
                    $scope.ProvinceList = data;
                    //根据当前机构的父级（即市的层级）获取对应的省的regionID
                    //目前情况为省市区三级联动，参数为$scope.editOrgModel.parentRegionID，若为省市两级联动，参数改为$scope.editOrgModel.regionID即可
                    var cityIDTemp = $scope.editOrgModel.regionID;
                    if($scope.editOrgModel.levelType == 3){
                        cityIDTemp = $scope.editOrgModel.parentRegionID;
                    }
                    areaRegionService.getProvincesByCityID(cityIDTemp).success(function (resp) {
                        if(resp){
                            $scope.selectProvince = _.find($scope.ProvinceList, function (num) {
                                return num.regionID === resp.regionID;
                            });
                            if ($scope.selectProvince) {
                                loadCityList($scope.selectProvince.regionID);
                            }
                        }
                    });

                } else {
                    data = null;
                    $scope.ProvinceList = data;
                    $scope.selectProvince = data;
                }
            });
        };

        // 加载城市信息
        var loadCityList = function (regionID) {
            regionID = $scope.selectProvince.regionID;
            if (regionID !== undefined && regionID !== null) {
                areaRegionService.getCities(regionID).success(function (data) {
                    if (data && data.length > 0) {
                        $scope.CityList = data;
                        $scope.selectCity = _.find($scope.CityList, function (num) {
                            if($scope.editOrgModel.levelType == 3){
                                return num.regionID === $scope.editOrgModel.parentRegionID;
                            }else if($scope.editOrgModel.levelType == 2){
                                return num.regionID === $scope.editOrgModel.regionID;
                            }
                        });

                        if ($scope.selectCity) {
                            loadDistrictList($scope.selectCity.regionID);
                        }

                    } else {
                        data = null;
                        $scope.CityList = data;
                        $scope.selectCity = data;
                    }
                });
            }
        };

        // 加载区县信息
        var loadDistrictList = function (regionID) {

            if (regionID !== undefined && regionID !== null) {
                areaRegionService.getDistricts(regionID).success(function (data) {
                    if (data && data.length > 0) {
                        $scope.DistrictList = data;

                        var target = _.find($scope.DistrictList, function (num) {
                            return num.regionID === $scope.editOrgModel.regionID;
                        });

                        if (target) {
                            $scope.selectRegionID = $scope.editOrgModel.regionID;
                        }else{
                            $scope.selectRegionID = "";
                        }

                    } else {
                        data = null;
                        $scope.DistrictList = data;
                        $scope.selectRegionID = "";
                    }
                });
            }else {
                $scope.DistrictList = null;
                $scope.selectRegionID = "";
            }
        };

        // 基础数据初始化
        var init = function () {
            // loadProjectIndustryList();
            loadOrganizationStructureService();
            loadBusinessUnitList();
            loadProvinceList();
            // loadEnterpriseAccountSetList();
            // getAllDimensionList();
            // loadprojectClient();
            initDatePicker();
        };

        // 验证账套
        var checkEnterpriseSetOrg = function () {
            if ($scope.orgAccountList && $scope.orgAccountList.length > 0) {
                $scope.orgAccountList.forEach(function (row) {

                    $scope.checkEnterpriseAccountSetSelect(row);
                    $scope.checkStartDate(row);
                    $scope.checkEndDate(row);
                });
            }

            var errorList = _.filter($scope.orgAccountList, function (num) {

                return num.enterpriseAccountSetSelectError || num.startDateError || num.endDateError;
            });

            if (errorList && errorList.length > 0) {
                return true;
            } else {
                return false;
            }
        };

        $scope.checkEnterpriseAccountSetSelect = function (row) {
            if (!row.enterpriseAccountSetSelectID && !row.startDate && !row.endDate) {
                row.enterpriseAccountSetSelectError = null;
                return;
            }

            if (!row.enterpriseAccountSetSelectID) {
                row.enterpriseAccountSetSelectError = $scope.resources.OrganizationMsgEnterpriseAccountSetRequired;
            } else {
                row.enterpriseAccountSetSelectError = null;
            }
        };

        // 验证开始时间
        $scope.checkStartDate = function (row) {

            if (row.startDate && !window.PWC.checkMonth(row.startDate)) {
                row.startDateError = $scope.resources.DateMonthFormatError;
                return;
            } else {
                row.startDateError = null;
            }

            if (!row.enterpriseAccountSetSelectID && !row.startDate && !row.endDate) {
                row.startDateError = null;
                return;
            }

            // if (!row.startDate) {
            //     row.startDateError = $scope.resources.EffectiveDateRequired;
            // } else {
            //     row.startDateError = null;
            // }

            if (row.startDate && row.endDate) {

                if (!validateDate(row.startDate, row.endDate)) {
                    row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                } else {
                    row.startDateError = null;
                }
            }
        };

        // 验证结束时间
        $scope.checkEndDate = function (row) {


            // if (!row.endDate) {
            //     row.endDateError = $scope.resources.ExpiredDateRequired;
            // } else {
            //     row.endDateError = null;
            // }

            if (row.endDate && !window.PWC.checkMonth(row.endDate)) {
                row.endDateError = $scope.resources.DateMonthFormatError;
                return;
            } else {
                row.endDateError = null;
            }

            if (!row.enterpriseAccountSetSelectID && !row.startDate && !row.endDate) {
                row.endDateError = null;
                return;
            }


            if (row.startDate && row.endDate) {

                if (!validateDate(row.startDate, row.endDate)) {
                    row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                } else {
                    row.startDateError = null;
                }
            }
        };

        // 验证模板列表
        var checkTemplateList = function () {
            var hasError = false;
            if ($scope.isCheckedServiceList && $scope.isCheckedServiceList.length > 0) {
                $scope.isCheckedServiceList.forEach(function (row) {
                    $scope.checkTemplate(row);
                    if (row.selectedTemplateError) {
                        hasError = true;
                    }
                });
            }

            return hasError;
        };

        // 验证模板方法
        $scope.checkTemplate = function (row) {
            if (row.isChecked) {
                if (!row.selectedTemplate) {
                    row.selectedTemplateError = $scope.resources.OrganizationMsgTemplateRequired;
                } else {
                    row.selectedTemplateError = null;
                }
            } else {
                row.selectedTemplateError = null;
            }
        };

        // 添加一行账套设置
        $scope.newOrgAccountRow = function () {
            var index = $scope.OrgAccountRowIndex;
            // var enterpriseAccountSetList = copyArray($scope.enterpriseAccountSetList);
            var d = new Date();
            var now = d.formatDateTime('yyyy-MM');

            var row = {
                // enterpriseAccountSetList: enterpriseAccountSetList,
                // enterpriseAccountSetSelect: null,
                startDate: null,
                endDate: null,
                fromID: 'orgFrom' + index,
                toID: 'orgTo' + index
            };

            $scope.OrgAccountRowIndex++;
            $scope.orgAccountList.push(row);
            $timeout(function () {
                setDatepickerRow(row);
            }, 200);
        };

        // 删除一行账套
        $scope.deleteAccountModule = function (model) {
            if (model) {
                $scope.orgAccountList.splice(jQuery.inArray(model, $scope.orgAccountList), 1);
            }
        };

        // 选择自定义属性校验
        $scope.checkSelfDimension = function (row) {
            if (row.isMandatory && row.dimensionValueList && row.dimensionValueList.length > 0) {
                if (!row.selectDimensionValueID) {
                    row.error = $translate.instant('PleaseSelect');
                    return;
                }
            }

            row.error = '';
        };

        // 修改机构时，设置账套设置的值
        var setEnterpriseOrgRowList = function (enterpriseAccountSetData) {
            $scope.orgAccountList = [];
            if (!enterpriseAccountSetData.enterpriseAccountSetOrgList || enterpriseAccountSetData.enterpriseAccountSetOrgList.length === 0) {
                return;
            }
            var enterpriseAccountSetList = copyArray($scope.enterpriseAccountSetList);

            enterpriseAccountSetData.enterpriseAccountSetOrgList.forEach(function (row) {
                var index = $scope.OrgAccountRowIndex;
                var rowData = {
                    enterpriseAccountSetList: enterpriseAccountSetList,
                    enterpriseAccountSetSelectID: row.enterpriseAccountSetID,
                    startDate: row.effectiveDateStr,
                    endDate: row.expiredDateStr,
                    fromID: 'orgFrom' + index,
                    toID: 'orgTo' + index,
                    id:row.id,
                };

                $scope.OrgAccountRowIndex++;

                $scope.orgAccountList.push(rowData);
                $timeout(function () {
                    setDatepickerRow(rowData);
                }, 100);
            });

        };

        // 设置时间控件
        var setDatepickerRow = function (rowData) {
            $("#" + rowData.fromID).datepicker({
                minViewMode: 1,
                autoclose: true,
                language: "zh-CN",
                format: "yyyy-mm"
            });

            $("#" + rowData.toID).datepicker({
                minViewMode: 1,
                autoclose: true,
                language: "zh-CN",
                format: "yyyy-mm"
            });

            $("#" + rowData.fromID).on('changeDate', function () {

                if ($("#" + rowData.fromID).val === '') {

                } else {
                    $("#" + rowData.toID).datepicker('setStartDate', $("#" + rowData.fromID).val());
                }
            });

            // 默认的错误信息先设置为空
            rowData.startDateError = null;
            rowData.endDateError = null;
        };

        // 数组复制
        var copyArray = function (data) {
            var ret = [];
            data.forEach(function (row) {

                ret.push(row);
            });

            return ret;
        };

        // 说明
        $scope.resources = {
            OrganizationName: $translate.instant('OrganizationName'),
            OrganizationNameEn: $translate.instant('OrganizationNameEn'),
            RegistrationCapital: $translate.instant('RegistrationCapital'),
            LegalPersonName: $translate.instant('LegalPersonName'),
            NumOfBranches: $translate.instant('NumOfBranches'),
            BusinessScope: $translate.instant('BusinessScope'),
            UnifiedSocialCreditCode: $translate.instant('UnifiedSocialCreditCode'),
            Abbreviation: $translate.instant('Abbreviation'),
            RegistrationLocationEn: $translate.instant('RegistrationLocationEn'),

            PaidInCapital: $translate.instant('PaidInCapital'),
            FoundationDate: $translate.instant('FoundationDate'),

            registrationLocation: $translate.instant('RegistrationLocation'),
            OrganizationMsgNameRequired: $translate.instant('OrganizationMsgNameRequired'),
            OrganizationParent: $translate.instant('OrganizationParent'),
            OrganizationLevelType: $translate.instant('OrganizationLevelType'),
            OrganizationMsgLevelTypeRequired: $translate.instant('OrganizationMsgLevelTypeRequired'),
            OrganizationClientCode: $translate.instant('OrganizationClientCode'),
            OrganizationMsgClientCodeRequired: $translate.instant('OrganizationMsgClientCodeRequired'),
            OrganizationCode: $translate.instant('OrganizationCode'),
            OrganizationMsgCodeRequired: $translate.instant('OrganizationMsgCodeRequired'),
            OrganizationMsgCodeMaxLength: $translate.instant('OrganizationMsgCodeMaxLength'),
            OrganizationMsgCodePattern: $translate.instant('OrganizationMsgCodePattern'),
            OrganizationMsgCodeUnique: $translate.instant('OrganizationMsgCodeUnique'),
            OrganizationTaxPayerNumber: $translate.instant('OrganizationTaxPayerNumber'),
            OrganizationMsgTaxPayerNumberUnique: $translate.instant('OrganizationMsgTaxPayerNumberUnique'),
            OrganizationMsgAreaRequired: $translate.instant('OrganizationMsgAreaRequired'),
            OrganizationMsgProvinceRequired: $translate.instant('OrganizationMsgProvinceRequired'),
            OrganizationMsgRegStatusRequired: $translate.instant('OrganizationMsgRegStatusRequired'),
            OrganizationMsgEngageNationalProhibitIndustryRequired: $translate.instant('OrganizationMsgEngageNationalProhibitIndustryRequired'),
            OrganizationMsgArchitectureTypeRequired: $translate.instant('OrganizationMsgArchitectureTypeRequired'),
            OrganizationMsgCityRequired: $translate.instant('OrganizationMsgCityRequired'),
            OrganizationMsgEnterpriseAccountSetRequired: $translate.instant('OrganizationMsgEnterpriseAccountSetRequired'),
            EffectiveDateRequired: $translate.instant('EffectiveDateRequired'),
            ExpiredDateRequired: $translate.instant('ExpiredDateRequired'),
            EffectiveDateAreaProblem: $translate.instant('EffectiveDateAreaProblem'),
            OrganizationMsgTemplateRequired: $translate.instant('OrganizationMsgTemplateRequired'),
            OrganizationMsgProjectIndustryRequired: $translate.instant('OrganizationMsgProjectIndustryRequired'),
            DateMonthFormatError: $translate.instant('DateMonthFormatError')
        };

        // 行业发生改变时，只有在已经做过科目对应的机构，且行业是非房地产和房地产 切换时，才需要给出需要重新做科目对应的提示
        $scope.ProjectIndustryChanged = function () {

            //添加机构，过滤,  如果没有做过科目对应，过滤
            if ($scope.isAdd || !$scope.orgHasAccountMapping) {
                return;
            }

            var com = $scope.selectCompany;
            var industry = $scope.selectProjectIndustry;
            if (!industry || !com)
                return;

            var orgID = $scope.selectCompany.id;
            //房地产行业ID
            var Estateid = constant.organization.EstateIndustryId;
            ////仅仅在房地产行业和非房地产行业之间切换时给予提示
            if (com.industryID != industry.id) {
                if (com.industryID == Estateid && industry.id != Estateid) {
                    SweetAlert.warning($translate.instant("OrganizationIndustryChanged"));
                }
                else if (com.industryID != Estateid && industry.id == Estateid) {
                    SweetAlert.warning($translate.instant("OrganizationIndustryChanged"));
                }
                ////仅仅在房地产行业和非房地产行业之间切换时给予提示
                //if (com.industryID != Estateid && industry.id != Estateid)
                //    return;

                //SweetAlert.warning($translate.instant("OrganizationIndustryChanged"));
            }
        };


        $scope.$watch('operateType', function (newValue, oldValue) {
            if (newValue) {

                if (newValue == constant.Operation.Add) {
                    // add
                    newOrg();
                } else if (newValue == constant.Operation.Edit) {
                    if ($scope.selectedOrganization) {
                        loadOrg($scope.selectedOrganization.id);
                    }
                }
            }
        });

        $scope.$watch('forceUpdate', function (newValue, oldValue) {
            if (newValue) {
                $scope.forceUpdate = false;
                initParams();
                init();
            }
        });


        $scope.changeInternational = function () {
            $scope.isLocal = false;
            $scope.isInternational = true;
            $('.localRequired').removeAttr("required");
            $('.orgAreaRequired').removeAttr("required");
        };

        $scope.changeLocal = function () {
            $scope.isLocal = true;
            $scope.isInternational = false;
            $('.localRequired').attr("required",true);
            $('.orgAreaRequired').attr("required",true);
        };

        // 强制刷新机构控件里的机构
        var refreshOrg = function () {
            $scope.editOrgModel.componentSelectedOrg = {};
            $scope.editOrgModel.componentSelectedOrg.forceRefresh = true;
        };

        $(".addOrgControlPop").on("hidden.bs.modal", function () {
            $('.modal-backdrop').remove();
            $(".addOrgControlPop").hide();
            $scope.operateType = null;

        });

        $scope.closeModal = function () {
            $scope.operateType = null;
        };

        // 初始化参数信息
        var initParams = function () {
            $scope.editOrgModel = {};
            $scope.selectCompany = {};
            $scope.isLocal = true;
            // 登记状态
            $scope.regStatusList = constant.RegStatusList;
            $scope.architectureTypeList = constant.ArchitectureTypeList;
            $scope.nationalEconomicIndustryList = constant.NationalEconomicIndustryList;
            $scope.trueFalse = constant.trueFalse;
            $scope.countryCNList = constant.countryCNList;
            $('.localRequired').attr("required",true);
            $('.orgAreaRequired').attr("required",true);

            // $('.localRequired').attr("required","true"); required="required"
        };

        // 省改变时联动市
        $scope.populateCities = function () {
            var regionID = $scope.selectProvince && $scope.selectProvince.regionID;
            loadCityList(regionID);
        };

        // 市改变时联动区
        $scope.populateDistricts = function () {
            var regionID = $scope.selectCity && $scope.selectCity.regionID;
            loadDistrictList(regionID);
        };

        // 验证是否为时间段
        var validateDate = function (from, to) {
            var fromDate = new Date(from + '-01');
            var toDate = new Date(to + '-01');
            toDate.setMonth(toDate.getMonth() + 1);
            toDate.setDate(toDate.getDate() - 1);

            if (fromDate <= toDate) {
                return true;
            } else {
                return false;
            }
        };

        // 获取添加自定义纬度列表
        var getAddOrgSetDimension = function () {

            var dimensionList = _.filter($scope.dimensionList, function (data) {
                return data.dimensionType === constant.dimensionType.SelfDimension;
            });

            if (dimensionList && dimensionList.length > 0) {
                var rightList = [];
                var leftList = [];

                for (var i = 0; i < dimensionList.length; i++) {
                    var row = dimensionList[i];

                    // 初始化的时候不选择值
                    row.selectDimensionValueID = '';
                    if (i % 2 === 1) {
                        leftList.push(row);
                    } else {
                        rightList.push(row);
                    }
                }

                var model = {
                    leftList: leftList,
                    rightList: rightList
                };

                return model;
            }

            return {
                leftList: [],
                rightList: []
            };
        };

        var initDatePicker = function () {
            var ele = $(".startDatepicker");
            ele.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: 'yyyy/mm/dd' //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele.datepicker("setDate", new Date().formatDateTime('yyyy/mm/dd'));

        };

        // 获取修改机构的时候，自定义维度列表
        var getUpdateOrgSetDimension = function (orgid, dimensionValueOrgList) {
            var dimensionList = _.filter($scope.dimensionList, function (data) {
                return data.dimensionType === constant.dimensionType.SelfDimension;
            });

            if (dimensionList && dimensionList.length > 0) {
                var rightList = [];
                var leftList = [];

                for (var i = 0; i < dimensionList.length; i++) {
                    var row = dimensionList[i];

                    // 设置默认选中值
                    var selectObj = _.find(dimensionValueOrgList, function (data) {
                        return data.dimensionID === row.id && data.organizationID === orgid;
                    });

                    row.selectDimensionValueID = selectObj ? selectObj.dimensionValueID : '';

                    if (i % 2 === 1) {
                        leftList.push(row);
                    } else {
                        rightList.push(row);
                    }
                }

                var model = {
                    leftList: leftList,
                    rightList: rightList
                };

                return model;
            }

            return {
                leftList: [],
                rightList: []
            };
        };

        (function initialize() {
            $log.debug('editOrganizationModalController.ctor()...');
            $scope.maxdropLength = 20;
            $scope.maxTitleLength = 10;
            initParams();
            init();
        })();
    }
]);
